import fischertechnik.utility.math as ft_math
import math
import threading
import time
from fischertechnik.controller.Motor import Motor
from lib.controller import *
from lib.display import *

kp = None
ki = None
kd = None
speed = None
i1 = None
speed_slow = None
started = None
i2 = None
speed_fwd = None
calib_i1_min = None
calib_i1_max = None
line = None
speed_m2 = None
speed_m1 = None
pid = None
calib_i2_min = None
calib_i2_max = None
white = None
control = None
endline = None
line_last = None
p = None
i = None
d = None
ts_diff = None
ts_diff0 = None
mode = None
ts0 = None
ts_offset = None
sampletime = None
ts1 = None


def calib_line_rotate360():
    global kp, ki, kd, speed, i1, speed_slow, started, i2, speed_fwd, calib_i1_min, calib_i1_max, line, speed_m2, speed_m1, pid, calib_i2_min, calib_i2_max, white, control, endline, line_last, p, i, d, ts_diff, ts_diff0, mode, ts0, ts_offset, sampletime, ts1
    TXT_M_M1_encodermotor.set_speed(int(200), Motor.CCW)
    TXT_M_M2_encodermotor.set_speed(int(200), Motor.CW)
    TXT_M_M1_encodermotor.set_distance(int(323), TXT_M_M2_encodermotor)
    while not (not TXT_M_M1_encodermotor.is_running()):
        calib_i1_min = min([calib_i1_min, TXT_M_I1_color_sensor.get_voltage()])
        calib_i1_max = max([calib_i1_max, TXT_M_I1_color_sensor.get_voltage()])
        calib_i2_min = min([calib_i2_min, TXT_M_I2_color_sensor.get_voltage()])
        calib_i2_max = max([calib_i2_max, TXT_M_I2_color_sensor.get_voltage()])
        time.sleep(0.01)
    print('calibLine min:{} {} max:{} {}'.format(calib_i1_min, calib_i2_min, calib_i1_max, calib_i2_max))


def threadDisplay():
    global kp, ki, kd, speed, i1, speed_slow, started, i2, speed_fwd, calib_i1_min, calib_i1_max, line, speed_m2, speed_m1, pid, calib_i2_min, calib_i2_max, white, control, endline, line_last, p, i, d, ts_diff, ts_diff0, mode, ts0, ts_offset, sampletime, ts1
    while True:
        if pid != None:
            kp = pid.Kp
            ki = pid.Ki
            kd = pid.Kd
            display.set_attr("txt_label_kp.text", str('Kp: {:.5f}'.format(kp)))
            display.set_attr("txt_label_ki.text", str('Ki: {:.5f}'.format(ki)))
            display.set_attr("txt_label_kd.text", str('Kd: {:.5f}'.format(kd)))
            if white:
                print('white:{} i12:{} {}'.format(white, i1, i2))
                time.sleep(1)
            elif endline:
                print('endline:{} i12:{} {}'.format(endline, i1, i2))
                time.sleep(1)
            else:
                if line != line_last:
                    p, i, d = pid.components
                    if False:
                        print('ts:{:.2f} ({:.2f}) line:{} control:{:.3f} speed:{} i12:{} {} m12: {} {} pid: {:.2f} {:.2f} {:.2f}'.format(ts_diff * 1000, ts_diff0 * 1000, line, control, speed, i1, i2, speed_m1, speed_m2, p, i, d))
                    line_last = line
            time.sleep(0.001)


def initPID(kp, ki, kd):
    global speed, i1, speed_slow, started, i2, speed_fwd, calib_i1_min, calib_i1_max, line, speed_m2, speed_m1, pid, calib_i2_min, calib_i2_max, white, control, endline, line_last, p, i, d, ts_diff, ts_diff0, mode, ts0, ts_offset, sampletime, ts1
    global pid
    from simple_pid import PID
    pid = PID(kp, ki, kd)
    pid.sample_time = sampletime
    pid.setpoint = 0.0
    pid.output_limits = (-512, 512)


def on_txt_button_start_clicked(event):
    global kp, ki, kd, speed, i1, speed_slow, started, i2, speed_fwd, calib_i1_min, calib_i1_max, line, speed_m2, speed_m1, pid, calib_i2_min, calib_i2_max, white, control, endline, line_last, p, i, d, ts_diff, ts_diff0, mode, ts0, ts_offset, sampletime, ts1
    initPID(0.006, 0.09, 0.0004)
    started = True


def on_txt_button_kpp_clicked(event):
    global kp, ki, kd, speed, i1, speed_slow, started, i2, speed_fwd, calib_i1_min, calib_i1_max, line, speed_m2, speed_m1, pid, calib_i2_min, calib_i2_max, white, control, endline, line_last, p, i, d, ts_diff, ts_diff0, mode, ts0, ts_offset, sampletime, ts1
    pid.Kp = pid.Kp + 0.0005
    pid.reset()


def on_txt_button_kpm_clicked(event):
    global kp, ki, kd, speed, i1, speed_slow, started, i2, speed_fwd, calib_i1_min, calib_i1_max, line, speed_m2, speed_m1, pid, calib_i2_min, calib_i2_max, white, control, endline, line_last, p, i, d, ts_diff, ts_diff0, mode, ts0, ts_offset, sampletime, ts1
    pid.Kp = pid.Kp - 0.0005
    if pid.Kp < 0:
      pid.Kp = 0
    pid.reset()


def on_txt_button_kip_clicked(event):
    global kp, ki, kd, speed, i1, speed_slow, started, i2, speed_fwd, calib_i1_min, calib_i1_max, line, speed_m2, speed_m1, pid, calib_i2_min, calib_i2_max, white, control, endline, line_last, p, i, d, ts_diff, ts_diff0, mode, ts0, ts_offset, sampletime, ts1
    pid.Ki = pid.Ki + 0.005
    pid.reset()


def on_txt_button_kim_clicked(event):
    global kp, ki, kd, speed, i1, speed_slow, started, i2, speed_fwd, calib_i1_min, calib_i1_max, line, speed_m2, speed_m1, pid, calib_i2_min, calib_i2_max, white, control, endline, line_last, p, i, d, ts_diff, ts_diff0, mode, ts0, ts_offset, sampletime, ts1
    pid.Ki = pid.Ki - 0.005
    if pid.Ki < 0:
      pid.Ki = 0
    pid.reset()


def on_txt_button_kdp_clicked(event):
    global kp, ki, kd, speed, i1, speed_slow, started, i2, speed_fwd, calib_i1_min, calib_i1_max, line, speed_m2, speed_m1, pid, calib_i2_min, calib_i2_max, white, control, endline, line_last, p, i, d, ts_diff, ts_diff0, mode, ts0, ts_offset, sampletime, ts1
    pid.Kd = pid.Kd + 0.005
    pid.reset()


def on_txt_button_kdm_clicked(event):
    global kp, ki, kd, speed, i1, speed_slow, started, i2, speed_fwd, calib_i1_min, calib_i1_max, line, speed_m2, speed_m1, pid, calib_i2_min, calib_i2_max, white, control, endline, line_last, p, i, d, ts_diff, ts_diff0, mode, ts0, ts_offset, sampletime, ts1
    pid.Kd = pid.Kd - 0.0005
    if pid.Kd < 0:
      pid.Kd = 0
    pid.reset()


def readSensors():
    global kp, ki, kd, speed, i1, speed_slow, started, i2, speed_fwd, calib_i1_min, calib_i1_max, line, speed_m2, speed_m1, pid, calib_i2_min, calib_i2_max, white, control, endline, line_last, p, i, d, ts_diff, ts_diff0, mode, ts0, ts_offset, sampletime, ts1
    i1 = ft_math.map(TXT_M_I1_color_sensor.get_voltage(), calib_i1_min, calib_i1_max, 100, 0)
    i2 = ft_math.map(TXT_M_I2_color_sensor.get_voltage(), calib_i2_min, calib_i2_max, 100, 0)
    line = i1 - i2
    white = i1 > 90 and i2 > 90
    endline = i1 < 10 and i2 < 10


def calcSpeed():
    global kp, ki, kd, speed, i1, speed_slow, started, i2, speed_fwd, calib_i1_min, calib_i1_max, line, speed_m2, speed_m1, pid, calib_i2_min, calib_i2_max, white, control, endline, line_last, p, i, d, ts_diff, ts_diff0, mode, ts0, ts_offset, sampletime, ts1
    speed = round(control) * 2
    if speed > 0:
        speed_m2 = min(max(speed_fwd - speed, -512), 0)
        speed_m1 = min(max(speed_fwd + speed, 0), 512)
    elif speed < 0:
        speed_m1 = min(max(speed_fwd - speed, -512), 0)
        speed_m2 = min(max(speed_fwd + speed, 0), 512)
    else:
        speed_m1 = speed_fwd
        speed_m2 = speed_fwd


display.button_clicked("txt_button_start", on_txt_button_start_clicked)
display.button_clicked("txt_button_kpp", on_txt_button_kpp_clicked)
display.button_clicked("txt_button_kpm", on_txt_button_kpm_clicked)
display.button_clicked("txt_button_kip", on_txt_button_kip_clicked)
display.button_clicked("txt_button_kim", on_txt_button_kim_clicked)
display.button_clicked("txt_button_kdp", on_txt_button_kdp_clicked)
display.button_clicked("txt_button_kdm", on_txt_button_kdm_clicked)


speed = 512
speed_slow = 110
speed_fwd = 350
speed_m1 = 0
speed_m2 = 0
calib_i1_min = 2000
calib_i1_max = 100
calib_i2_min = 2000
calib_i2_max = 100
white = False
endline = False
line = 0
i1 = 0
i2 = 0
mode = 0
control = 0
ts0 = time.time()
ts_diff0 = 0
ts_diff = 0
ts_offset = 0.0002
#pid.sample_time = None #If set to None, the PID will compute a new output value every time it is called
if False:
    sampletime = 0.005
else:
    sampletime = None
started = False
display.set_attr("txt_button_start.enabled", str(True).lower())
while True:
    if started:
        break
    time.sleep(0.010)
calib_line_rotate360()
threading.Thread(target=threadDisplay, daemon=True).start()
while True:
    if white:
        TXT_M_M1_encodermotor.stop()
        TXT_M_M2_encodermotor.stop()
        speed = 0
        pid.reset()
        readSensors()
    elif endline:
        TXT_M_M1_encodermotor.set_speed(int(512), Motor.CW)
        TXT_M_M2_encodermotor.set_speed(int(512), Motor.CCW)
        TXT_M_M1_encodermotor.set_distance(int(128), TXT_M_M2_encodermotor)
        while True:
            if ((not TXT_M_M1_encodermotor.is_running()) and (not TXT_M_M2_encodermotor.is_running())):
                break
            time.sleep(0.010)
        speed = 0
        pid.reset()
        readSensors()
    else:
        ts0 = time.time()
        readSensors()
        control = pid(line)
        calcSpeed()
        TXT_M_M1_encodermotor.set_speed(int(speed_m1), Motor.CCW)
        TXT_M_M1_encodermotor.start()
        TXT_M_M2_encodermotor.set_speed(int(speed_m2), Motor.CCW)
        TXT_M_M2_encodermotor.start()
        if sampletime == None:
            pass
        else:
            if ts_diff0 + ts_offset < sampletime:
                time.sleep(((sampletime - ts_diff0) - ts_offset))
            else:
                print('sample_time {}ms exceeded ts:{:.2f}ms'.format(sampletime * 1000, ts_diff * 1000))
        ts1 = time.time()
        ts_diff0 = ts1 - ts0
        ts_diff = time.time() - ts0


